package org.xdoclet.plugin.hibernate.qtags;

public class HibernateClassTagImpl extends org.xdoclet.XDocletTag implements org.xdoclet.plugin.hibernate.qtags.HibernateClassTag {
    public static final String NAME = "hibernate.class";
    private static final java.util.List ALLOWED_PARAMETERS = java.util.Arrays.asList( new String[] {
		"optimistic-lock",
		"polymorphism",
		"lazy",
		"check",
		"select-before-update",
		"dynamic-update",
		"subselect",
		"schema",
		"entity-name",
		"table",
		"dynamic-insert",
		"where",
		"name",
		"proxy",
		"rowid",
		"node",
		"mutable",
		"batch-size",
		"catalog",
		"persister",
		"abstract",
		"discriminator-value",
    	""
    });
    
    private static final java.util.List ALLOWED_VALUES = java.util.Arrays.asList( new String[] {
        ""
    });
    public HibernateClassTagImpl(String name, String value, com.thoughtworks.qdox.model.AbstractBaseJavaEntity entity, int lineNumber, org.xdoclet.QDoxPropertyExpander expander) {
        super(name, value, entity, lineNumber, expander);
    }
    public HibernateClassTagImpl(String name, String value, com.thoughtworks.qdox.model.AbstractBaseJavaEntity entity, int lineNumber) {
        super(name, value, entity, lineNumber);
    }

    public java.lang.String getOptimisticLock() {
		boolean required = false;
        String result = getNamedParameter("optimistic-lock");
        if(required && result == null) {
            bomb("optimistic-lock=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            if( !(false || result.equals("none")|| result.equals("dirty")|| result.equals("version")|| result.equals("all")) ) {
	                // todo we should say what file and line number too
	                bomb("optimistic-lock=\"" + result + "\" is an invalid parameter value.");
	            }
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getPolymorphism() {
		boolean required = false;
        String result = getNamedParameter("polymorphism");
        if(required && result == null) {
            bomb("polymorphism=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            if( !(false || result.equals("explicit")|| result.equals("implicit")) ) {
	                // todo we should say what file and line number too
	                bomb("polymorphism=\"" + result + "\" is an invalid parameter value.");
	            }
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getLazy() {
		boolean required = false;
        String result = getNamedParameter("lazy");
        if(required && result == null) {
            bomb("lazy=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            if( !(false || result.equals("true")|| result.equals("false")|| result.equals("proxy")|| result.equals("no-proxy")|| result.equals("extra")) ) {
	                // todo we should say what file and line number too
	                bomb("lazy=\"" + result + "\" is an invalid parameter value.");
	            }
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getCheck() {
		boolean required = false;
        String result = getNamedParameter("check");
        if(required && result == null) {
            bomb("check=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.Boolean getSelectBeforeUpdate() {
		boolean required = false;
        String result = getNamedParameter("select-before-update");
        if(required && result == null) {
            bomb("select-before-update=\"???\" must be specified.");
        }

		java.lang.Boolean retVal = null;


		if (result != null) {
		        retVal = Boolean.valueOf(result);
		}
		
		return retVal;
    }
    public java.lang.Boolean getDynamicUpdate() {
		boolean required = false;
        String result = getNamedParameter("dynamic-update");
        if(required && result == null) {
            bomb("dynamic-update=\"???\" must be specified.");
        }

		java.lang.Boolean retVal = null;


		if (result != null) {
		        retVal = Boolean.valueOf(result);
		}
		
		return retVal;
    }
    public java.lang.String getSubselect() {
		boolean required = false;
        String result = getNamedParameter("subselect");
        if(required && result == null) {
            bomb("subselect=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getSchema() {
		boolean required = false;
        String result = getNamedParameter("schema");
        if(required && result == null) {
            bomb("schema=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getEntityName() {
		boolean required = false;
        String result = getNamedParameter("entity-name");
        if(required && result == null) {
            bomb("entity-name=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getTable() {
		boolean required = false;
        String result = getNamedParameter("table");
        if(required && result == null) {
            bomb("table=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.Boolean getDynamicInsert() {
		boolean required = false;
        String result = getNamedParameter("dynamic-insert");
        if(required && result == null) {
            bomb("dynamic-insert=\"???\" must be specified.");
        }

		java.lang.Boolean retVal = null;


		if (result != null) {
		        retVal = Boolean.valueOf(result);
		}
		
		return retVal;
    }
    public java.lang.String getWhere() {
		boolean required = false;
        String result = getNamedParameter("where");
        if(required && result == null) {
            bomb("where=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getName_() {
		boolean required = false;
        String result = getNamedParameter("name");
        if(required && result == null) {
            bomb("name=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getProxy() {
		boolean required = false;
        String result = getNamedParameter("proxy");
        if(required && result == null) {
            bomb("proxy=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getRowid() {
		boolean required = false;
        String result = getNamedParameter("rowid");
        if(required && result == null) {
            bomb("rowid=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getNode() {
		boolean required = false;
        String result = getNamedParameter("node");
        if(required && result == null) {
            bomb("node=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.Boolean getMutable() {
		boolean required = false;
        String result = getNamedParameter("mutable");
        if(required && result == null) {
            bomb("mutable=\"???\" must be specified.");
        }

		java.lang.Boolean retVal = null;


		if (result != null) {
		        retVal = Boolean.valueOf(result);
		}
		
		return retVal;
    }
    public java.lang.String getBatchSize() {
		boolean required = false;
        String result = getNamedParameter("batch-size");
        if(required && result == null) {
            bomb("batch-size=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getCatalog() {
		boolean required = false;
        String result = getNamedParameter("catalog");
        if(required && result == null) {
            bomb("catalog=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getPersister() {
		boolean required = false;
        String result = getNamedParameter("persister");
        if(required && result == null) {
            bomb("persister=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.Boolean getAbstract() {
		boolean required = false;
        String result = getNamedParameter("abstract");
        if(required && result == null) {
            bomb("abstract=\"???\" must be specified.");
        }

		java.lang.Boolean retVal = null;


		if (result != null) {
		        retVal = Boolean.valueOf(result);
		}
		
		return retVal;
    }
    public java.lang.String getDiscriminatorValue() {
		boolean required = false;
        String result = getNamedParameter("discriminator-value");
        if(required && result == null) {
            bomb("discriminator-value=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }

    protected void validateLocation() {
        if(isOnField) {
            bomb("is not allowed on fields");
        }
		if(isOnConstructor) {
        	bomb("is not allowed on constructors");
		}
		if(isOnMethod) {
        	bomb("is not allowed on methods");
		}
        
        // check uniqueness
        // deprecated here. check validateModel
		if(((com.thoughtworks.qdox.model.AbstractJavaEntity)getContext()).getTagsByName(NAME).length > 1) {
			bomb("is allowed only once");
		}

        // warn deprecation
        
        // check for allowed values for whole tag
        if( ALLOWED_VALUES.size() > 1 && !ALLOWED_VALUES.contains(getValue())) {
            bomb( "\"" + getValue() +"\" is not a valid value. Allowed values are ");
        }        
        // Verify that all parameters are known.
        final java.util.Collection parameterNames = getNamedParameterMap().keySet();
        for (java.util.Iterator iterator = parameterNames.iterator(); iterator.hasNext();) {
            String parameterName = (String) iterator.next();
            if (!ALLOWED_PARAMETERS.contains(parameterName)) {
                bomb(parameterName + " is an invalid parameter name.");
            }
        }
        
        // Get all the parameters to validate their contents
        getOptimisticLock();
        getPolymorphism();
        getLazy();
        getCheck();
        getSelectBeforeUpdate();
        getDynamicUpdate();
        getSubselect();
        getSchema();
        getEntityName();
        getTable();
        getDynamicInsert();
        getWhere();
        getName_();
        getProxy();
        getRowid();
        getNode();
        getMutable();
        getBatchSize();
        getCatalog();
        getPersister();
        getAbstract();
        getDiscriminatorValue();
    }

    public void validateModel() {
        // check uniqueness
        if(((com.thoughtworks.qdox.model.AbstractJavaEntity)getContext()).getTagsByName(NAME).length > 1) {
            bomb("is allowed only once");
        }
    }
}