package org.xdoclet.plugin.hibernate.qtags;

public class HibernateComponentTagImpl extends org.xdoclet.XDocletTag implements org.xdoclet.plugin.hibernate.qtags.HibernateComponentTag {
    public static final String NAME = "hibernate.component";
    private static final java.util.List ALLOWED_PARAMETERS = java.util.Arrays.asList( new String[] {
		"optimistic-lock",
		"prefix",
		"lazy",
		"properties-name",
		"insert",
		"node",
		"unique",
		"join-name",
		"update",
		"class",
		"access",
    	""
    });
    
    private static final java.util.List ALLOWED_VALUES = java.util.Arrays.asList( new String[] {
        ""
    });
    public HibernateComponentTagImpl(String name, String value, com.thoughtworks.qdox.model.AbstractBaseJavaEntity entity, int lineNumber, org.xdoclet.QDoxPropertyExpander expander) {
        super(name, value, entity, lineNumber, expander);
    }
    public HibernateComponentTagImpl(String name, String value, com.thoughtworks.qdox.model.AbstractBaseJavaEntity entity, int lineNumber) {
        super(name, value, entity, lineNumber);
    }

    public java.lang.Boolean getOptimisticLock() {
		boolean required = false;
        String result = getNamedParameter("optimistic-lock");
        if(required && result == null) {
            bomb("optimistic-lock=\"???\" must be specified.");
        }

		java.lang.Boolean retVal = null;


		if (result != null) {
		        retVal = Boolean.valueOf(result);
		}
		
		return retVal;
    }
    public java.lang.String getPrefix() {
		boolean required = false;
        String result = getNamedParameter("prefix");
        if(required && result == null) {
            bomb("prefix=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getLazy() {
		boolean required = false;
        String result = getNamedParameter("lazy");
        if(required && result == null) {
            bomb("lazy=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            if( !(false || result.equals("true")|| result.equals("false")|| result.equals("proxy")|| result.equals("no-proxy")|| result.equals("extra")) ) {
	                // todo we should say what file and line number too
	                bomb("lazy=\"" + result + "\" is an invalid parameter value.");
	            }
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getPropertiesName() {
		boolean required = false;
        String result = getNamedParameter("properties-name");
        if(required && result == null) {
            bomb("properties-name=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.Boolean getInsert() {
		boolean required = false;
        String result = getNamedParameter("insert");
        if(required && result == null) {
            bomb("insert=\"???\" must be specified.");
        }

		java.lang.Boolean retVal = null;


		if (result != null) {
		        retVal = Boolean.valueOf(result);
		}
		
		return retVal;
    }
    public java.lang.String getNode() {
		boolean required = false;
        String result = getNamedParameter("node");
        if(required && result == null) {
            bomb("node=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.Boolean getUnique() {
		boolean required = false;
        String result = getNamedParameter("unique");
        if(required && result == null) {
            bomb("unique=\"???\" must be specified.");
        }

		java.lang.Boolean retVal = null;


		if (result != null) {
		        retVal = Boolean.valueOf(result);
		}
		
		return retVal;
    }
    public java.lang.String getJoinName() {
		boolean required = false;
        String result = getNamedParameter("join-name");
        if(required && result == null) {
            bomb("join-name=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.Boolean getUpdate() {
		boolean required = false;
        String result = getNamedParameter("update");
        if(required && result == null) {
            bomb("update=\"???\" must be specified.");
        }

		java.lang.Boolean retVal = null;


		if (result != null) {
		        retVal = Boolean.valueOf(result);
		}
		
		return retVal;
    }
    public java.lang.String getClass_() {
		boolean required = false;
        String result = getNamedParameter("class");
        if(required && result == null) {
            bomb("class=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getAccess() {
		boolean required = false;
        String result = getNamedParameter("access");
        if(required && result == null) {
            bomb("access=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }

    protected void validateLocation() {
		if(isOnClass) {
        	bomb("is not allowed on classes");
		}
		if(isOnConstructor) {
        	bomb("is not allowed on constructors");
		}
        
        // check uniqueness

        // warn deprecation
        
        // check for allowed values for whole tag
        if( ALLOWED_VALUES.size() > 1 && !ALLOWED_VALUES.contains(getValue())) {
            bomb( "\"" + getValue() +"\" is not a valid value. Allowed values are ");
        }        
        // Verify that all parameters are known.
        final java.util.Collection parameterNames = getNamedParameterMap().keySet();
        for (java.util.Iterator iterator = parameterNames.iterator(); iterator.hasNext();) {
            String parameterName = (String) iterator.next();
            if (!ALLOWED_PARAMETERS.contains(parameterName)) {
                bomb(parameterName + " is an invalid parameter name.");
            }
        }
        
        // Get all the parameters to validate their contents
        getOptimisticLock();
        getPrefix();
        getLazy();
        getPropertiesName();
        getInsert();
        getNode();
        getUnique();
        getJoinName();
        getUpdate();
        getClass_();
        getAccess();
    }

    public void validateModel() {
        // check uniqueness
    }
}